﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using ClientEx.DTS;

namespace ClientEx
{
    public partial class FilterDialog : Form
    {
        public FilterDialog()
        {
            InitializeComponent();
        }

        // Input variables
        public string ObjectName = "";
        public string CounterName = "";
        public PerformanceObjectInstanceFilter instanceFilter = null;

        private void btnAdd_Click(object sender, EventArgs e)
        {
            // Add a filter to the dialog
            if (tbInstanceName.Text.Length > 0)
            {
                if (!this.lbInstances.Items.Contains(tbInstanceName.Text))
                    this.lbInstances.Items.Add(tbInstanceName.Text);
            }
        }

        private void EnableControls()
        {
            this.btnAdd.Enabled = this.tbInstanceName.Text.Length > 0;
            this.btnDelete.Enabled = this.lbInstances.SelectedIndex != -1;
        }

        private void FilterDialog_Load(object sender, EventArgs e)
        {
            // Add the instance filter
            if (instanceFilter != null)
            {
                for (int i = 0; i < instanceFilter.InstanceNames.Length; i++)
                {
                    lbInstances.Items.Add(instanceFilter.InstanceNames[i]);
                }
            }
        }

        private void btnOK_Click(object sender, EventArgs e)
        {
            DTS.PerformanceObjectInstanceFilter instanceFilter = new DTS.PerformanceObjectInstanceFilter();
            instanceFilter.ObjectName = this.ObjectName;
            instanceFilter.InstanceNames = new string[lbInstances.Items.Count];
            for (int i = 0; i < lbInstances.Items.Count; i++)
                instanceFilter.InstanceNames[i] = lbInstances.Items[i].ToString();
            this.instanceFilter = instanceFilter;
            this.DialogResult = DialogResult.OK;
            this.Close();
        }

        private void btnCancel_Click(object sender, EventArgs e)
        {
            this.DialogResult = DialogResult.Cancel;
            this.Close();
        }

        private void tbInstanceName_TextChanged(object sender, EventArgs e)
        {
            EnableControls();
        }

        private void btnDelete_Click(object sender, EventArgs e)
        {
            if (lbInstances.SelectedItem != null)
                lbInstances.Items.Remove(lbInstances.SelectedItem);
        }

        private void lbInstances_SelectedIndexChanged(object sender, EventArgs e)
        {
            EnableControls();
        }

        
    }
}
