# example script to list the objects being collected

# execute this before the script so that the DTS proxy variable is set up:
# $proxy = New-WebServiceProxy -Uri 'http://localhost:5557/DTSPSP' -namespace DTS
# this can only be done once per powershell session since powershell has a bug
# that will create a superfluous casting error if the proxy is created twice

function listobjects
{

$objectnames = $proxy.GetCollectionObjectNames()
if ($objectnames.Length -eq 0)
{
  Write-Host 'There were no objects being collected.'
  return
}

for ($i = 0; $i -lt $objectnames.Length; $i++)
{
  $message =  $message + $objectnames[$i] + "`r`n"
}

Write-Host $message

$message = $null
$objectnames = $null

}
